//
//  CAPackage.h
//  ScreenShredder
//
//  Created by Spotlight Deveaux on 2021-11-14.
//

#ifndef CAPackage_h
#define CAPackage_h

@import QuartzCore;

extern NSString *_Nonnull kCAPackageTypeArchive;

@interface CAPackage : NSObject

+ (CAPackage *_Nullable)packageWithContentsOfURL:(NSURL *_Nonnull)url
                                            type:(NSString *_Nonnull)type
                                         options:(NSDictionary *_Nullable)opts
                                           error:(NSError *_Nullable *_Nullable)
                                                     outError;

- (NSArray<NSString *> *_Nonnull)publishedObjectNames;
- (CALayer *_Nullable)publishedObjectWithName:(NSString *_Nonnull)name;

@property(readonly, getter=isGeometryFlipped) BOOL geometryFlipped;
@property(readonly) CALayer *_Nonnull rootLayer;

@end

#endif /* CAPackage_h */
