//
//  CAStateController.h
//  ScreenShredder
//
//  Created by Spotlight Deveaux on 2021-11-14.
//

#ifndef CAStateController_h
#define CAStateController_h

@import QuartzCore;
#import "CAState.h"

@interface CAStateController : NSObject

// TODO: Do we need to bother with delegates?
//@property(__weak) NSObject *<CAStateControllerDelegate> delegate;
//- (NSObject *<CAStateControllerDelegate>)delegate;
//- (void)setDelegate:(NSObject *<CAStateControllerDelegate>)delegate;
- (CALayer *_Nullable)layer;
- (void)_removeTransition:(id _Nonnull)arg1 layer:(CALayer *_Nonnull)arg2;
- (CAStateController *_Nonnull)initWithLayer:(CALayer *_Nonnull)layer;
- (CAState *_Nonnull)stateOfLayer:(CALayer *_Nonnull)arg1;
- (void)setState:(CAState *_Nonnull)state
            ofLayer:(CALayer *_Nonnull)layer
    transitionSpeed:(float)speed;
- (void)setState:(CAState *_Nonnull)state ofLayer:(CALayer *_Nonnull)layer;
- (void)setInitialStatesOfLayer:(CALayer *_Nonnull)layer
                transitionSpeed:(float)speed;
- (void)setInitialStatesOfLayer:(CALayer *_Nonnull)layer;

// TODO: What type is id in the beneath here?
- (id _Nonnull)removeAllStateChanges;
- (void)restoreStateChanges:(id _Nonnull)arg1;
- (void)cancelTimers;
- (void)_nextStateTimer:(id _Nonnull)arg1;
- (void)_addAnimation:(id _Nonnull)arg1
               forKey:(id _Nonnull)arg2
               target:(id _Nonnull)arg3
                 undo:(id _Nonnull)arg4;
@end

#endif /* CAStateController_h */
